// This file is public domain software (PDS).
// Copyright (C) 2018 Katayama Hirofumi MZ.
#include <windows.h>
#include <windowsx.h>
#include <dlgs.h>

BOOL OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    return TRUE;
}

void OnPsh1(HWND hwnd)
{
    INT ret1, ret2, ret3, ret4;
    RECT rcClipBox1, rcClipBox2, rcClipBox3, rcClipBox4;
    HDC hDC;

    SetRectEmpty(&rcClipBox1);
    hDC = GetDC(hwnd);
    if (hDC)
    {
        ret1 = GetClipBox(hDC, &rcClipBox1);
        ReleaseDC(hwnd, hDC);
    }

    SetRectEmpty(&rcClipBox2);
    hDC = GetDCEx(hwnd, NULL, DCX_WINDOW);
    if (hDC)
    {
        ret2 = GetClipBox(hDC, &rcClipBox2);
        ReleaseDC(hwnd, hDC);
    }

    SetRectEmpty(&rcClipBox3);
    hDC = GetDCEx(hwnd, NULL, DCX_CACHE);
    if (hDC)
    {
        ret3 = GetClipBox(hDC, &rcClipBox3);
        ReleaseDC(hwnd, hDC);
    }

    SetRectEmpty(&rcClipBox4);
    hDC = GetDCEx(hwnd, NULL, 0);
    if (hDC)
    {
        ret4 = GetClipBox(hDC, &rcClipBox4);
        ReleaseDC(hwnd, hDC);
    }

    TCHAR szText[512];
    wsprintf(szText,
        TEXT("ret1:%d, ret2:%d, ret3:%d, ret4:%d\r\n")
        TEXT("rcClipBox1: (%ld, %ld)-(%ld, %ld)\r\n")
        TEXT("rcClipBox2: (%ld, %ld)-(%ld, %ld)\r\n")
        TEXT("rcClipBox3: (%ld, %ld)-(%ld, %ld)\r\n")
        TEXT("rcClipBox4: (%ld, %ld)-(%ld, %ld)"),
        ret1, ret2, ret3, ret4,
        rcClipBox1.left, rcClipBox1.top, rcClipBox1.right, rcClipBox1.bottom,
        rcClipBox2.left, rcClipBox2.top, rcClipBox2.right, rcClipBox2.bottom,
        rcClipBox3.left, rcClipBox3.top, rcClipBox3.right, rcClipBox3.bottom,
        rcClipBox4.left, rcClipBox4.top, rcClipBox4.right, rcClipBox4.bottom);
    MessageBox(hwnd, szText, TEXT("Info"), MB_ICONINFORMATION);
}

void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK:
        EndDialog(hwnd, IDOK);
        break;
    case IDCANCEL:
        EndDialog(hwnd, IDCANCEL);
        break;
    case psh1:
        OnPsh1(hwnd);
        break;
    }
}

INT_PTR CALLBACK
DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_INITDIALOG, OnInitDialog);
        HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    }
    return 0;
}

INT WINAPI
WinMain(HINSTANCE   hInstance,
        HINSTANCE   hPrevInstance,
        LPSTR       lpCmdLine,
        INT         nCmdShow)
{
    DialogBox(hInstance, MAKEINTRESOURCE(1), NULL, DialogProc);
    return 0;
}
